/*
 * Copyright 2014 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.openhft.jpsg.collect.algo.hash;

import net.openhft.jpsg.collect.mapqu.*;


public final class Insert extends MapQueryUpdateMethod {

    @Override
    public BasicMapQueryUpdateOp baseOp() {
        return BasicMapQueryUpdateOp.CUSTOM_INSERT;
    }

    @Override
    public Branch mostProbableBranch() {
        return Branch.KEY_ABSENT;
    }

    @Override
    public void ifPresent() {
        gen.ret(((HashMapQueryUpdateMethodGenerator) gen).index());
    }

    @Override
    public void ifAbsent() {
        gen.insert("value");
        gen.ret("-1");
    }

    @Override
    public boolean inline() {
        return true;
    }

    @Override
    public String nullArgs() {
        return cxt.isMapView() ? "value" : "";
    }
}
